/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.113 Revision 1.221
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.113 2005/03/17 00:00:15 r3pek Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.221 2009/10/20 19:17:59 zmedico Exp $
4 4
5# Description: kernel.eclass rewrite for a clean base regarding the 2.6 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# series of kernel with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Maintainer: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
9# Copyright 2005 Gentoo Linux 9# Maintainer: kernel-misc@gentoo.org
10# 10#
11# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
12 12
13# added functionality: 13# added functionality:
14# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
22# EXTRAVERSION would be something like : -wolk-4.19-r1 22# EXTRAVERSION would be something like : -wolk-4.19-r1
23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
24# automatically set within the kernel Makefile 24# automatically set within the kernel Makefile
25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
26# first part of ${PN} in EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
27# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, 29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
28# ck-sources, ac-sources) it will use PR (ie: -r5) as 30# ck-sources, ac-sources) it will use PR (ie: -r5) as
29# the patchset version for 31# the patchset version for
30# and not use it as a true package revision 32# and not use it as a true package revision
31# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
32# postinst and can be used to carry additional postinst 34# postinst and can be used to carry additional postinst
33# messages 35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
34# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
35# K_SYMLINK - if this is set, then forcably create symlink anyway 38# K_SYMLINK - if this is set, then forcably create symlink anyway
36# 39#
37# K_DEFCONFIG - Allow specifying a different defconfig target. 40# K_DEFCONFIG - Allow specifying a different defconfig target.
38# If length zero, defaults to "defconfig". 41# If length zero, defaults to "defconfig".
42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
43# combination of "base" and "extras"
44# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
45# A value of "5" would apply genpatches-2.6.12-5 to
46# my-sources-2.6.12.ebuild
47# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
39 48
40# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which 49# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
41# can be supported by the headers ebuild 50# can be supported by the headers ebuild
42 51
43# UNIPATCH_LIST - space delimetered list of patches to be applied to the 52# UNIPATCH_LIST - space delimetered list of patches to be applied to the
49# UNIPATCH_DOCS - space delimemeted list of docs to be installed to 58# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
50# the doc dir 59# the doc dir
51# UNIPATCH_STRICTORDER - if this is set places patches into directories of 60# UNIPATCH_STRICTORDER - if this is set places patches into directories of
52# order, so they are applied in the order passed 61# order, so they are applied in the order passed
53 62
54inherit toolchain-funcs versionator multilib 63inherit eutils toolchain-funcs versionator multilib
55ECLASS="kernel-2"
56INHERITED="$INHERITED $ECLASS"
57EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install \ 64EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst
58 pkg_preinst pkg_postinst 65
66# Added by Daniel Ostrow <dostrow@gentoo.org>
67# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
68# I will remove it when I come up with something more reasonable.
69[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
59 70
60export CTARGET=${CTARGET:-${CHOST}} 71export CTARGET=${CTARGET:-${CHOST}}
61if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then 72if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
62 export CTARGET=${CATEGORY/cross-} 73 export CTARGET=${CATEGORY/cross-}
63fi 74fi
64 75
65HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 76HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
66LICENSE="GPL-2" 77LICENSE="GPL-2"
67 78
79# No need to run scanelf/strip on kernel sources/headers (bug #134453).
80RESTRICT="binchecks strip"
81
68# set LINUX_HOSTCFLAGS if not already set 82# set LINUX_HOSTCFLAGS if not already set
69[ -z "$LINUX_HOSTCFLAGS" ] && \ 83[[ -z ${LINUX_HOSTCFLAGS} ]] && \
70 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 84 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
85
86# debugging functions
87#==============================================================
88# this function exists only to help debug kernel-2.eclass
89# if you are adding new functionality in, put a call to it
90# at the start of src_unpack, or during SRC_URI/dep generation.
91debug-print-kernel2-variables() {
92 debug-print "PVR: ${PVR}"
93 debug-print "CKV: ${CKV}"
94 debug-print "OKV: ${OKV}"
95 debug-print "KV: ${KV}"
96 debug-print "KV_FULL: ${KV_FULL}"
97 debug-print "RELEASETYPE: ${RELEASETYPE}"
98 debug-print "RELEASE: ${RELEASE}"
99 debug-print "UNIPATCH_LIST_DEFAULT: ${UNIPATCH_LIST_DEFAULT} "
100 debug-print "UNIPATCH_LIST_GENPATCHES: ${UNIPATCH_LIST_GENPATCHES} "
101 debug-print "UNIPATCH_LIST: ${UNIPATCH_LIST}"
102 debug-print "S: ${S}"
103 debug-print "KERNEL_URI: ${KERNEL_URI}"
104}
71 105
72#Eclass functions only from here onwards ... 106#Eclass functions only from here onwards ...
73#============================================================== 107#==============================================================
108handle_genpatches() {
109 local tarball
110 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
111
112 for i in ${K_WANT_GENPATCHES} ; do
113 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2"
114 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
115 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
116 done
117}
118
119detect_version() {
120 # this function will detect and set
121 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
122 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
123 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
124
125 if [[ -n ${KV_FULL} ]]; then
126 # we will set this for backwards compatibility.
127 KV=${KV_FULL}
128
129 # we know KV_FULL so lets stop here. but not without resetting S
130 S=${WORKDIR}/linux-${KV_FULL}
131 return
132 fi
133
134 # CKV is used as a comparison kernel version, which is used when
135 # PV doesnt reflect the genuine kernel version.
136 # this gets set to the portage style versioning. ie:
137 # CKV=2.6.11_rc4
138 CKV=${CKV:-${PV}}
139 OKV=${OKV:-${CKV}}
140 OKV=${OKV/_beta/-test}
141 OKV=${OKV/_rc/-rc}
142 OKV=${OKV/-r*}
143 OKV=${OKV/_p*}
144
145 KV_MAJOR=$(get_version_component_range 1 ${OKV})
146 KV_MINOR=$(get_version_component_range 2 ${OKV})
147 KV_PATCH=$(get_version_component_range 3 ${OKV})
148
149 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
150 KV_EXTRA=$(get_version_component_range 4- ${OKV})
151 KV_EXTRA=${KV_EXTRA/[-_]*}
152 else
153 KV_PATCH=$(get_version_component_range 3- ${OKV})
154 fi
155 KV_PATCH=${KV_PATCH/[-_]*}
156
157 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
158
159 RELEASE=${CKV/${OKV}}
160 RELEASE=${RELEASE/_beta}
161 RELEASE=${RELEASE/_rc/-rc}
162 RELEASE=${RELEASE/_pre/-pre}
163 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
164 RELEASETYPE=${RELEASE//[0-9]}
165
166 # Now we know that RELEASE is the -rc/-git
167 # and RELEASETYPE is the same but with its numerics stripped
168 # we can work on better sorting EXTRAVERSION.
169 # first of all, we add the release
170 EXTRAVERSION="${RELEASE}"
171 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
172 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
173
174 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
175 if [[ -n "${K_NOUSEPR}" ]]; then
176 # Don't add anything based on PR to EXTRAVERSION
177 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
178 elif [[ -n ${K_PREPATCHED} ]]; then
179 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
180 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
181 elif [[ "${ETYPE}" = "sources" ]]; then
182 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
183 # For some sources we want to use the PV in the extra version
184 # This is because upstream releases with a completely different
185 # versioning scheme.
186 case ${PN/-*} in
187 wolk) K_USEPV=1;;
188 vserver) K_USEPV=1;;
189 esac
190
191 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
192 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
193 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
194 fi
195 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
196
197 # The only messing around which should actually effect this is for KV_EXTRA
198 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
199 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
200 if [[ -n ${KV_EXTRA} ]]; then
201 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
202 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/patch-${CKV}.bz2
203 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.tar.bz2"
204 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
205 fi
206
207 # We need to set this using OKV, but we need to set it before we do any
208 # messing around with OKV based on RELEASETYPE
209 KV_FULL=${OKV}${EXTRAVERSION}
210
211 # we will set this for backwards compatibility.
212 S=${WORKDIR}/linux-${KV_FULL}
213 KV=${KV_FULL}
214
215 # -rc-git pulls can be achieved by specifying CKV
216 # for example:
217 # CKV="2.6.11_rc3_pre2"
218 # will pull:
219 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2
220
221 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
222 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
223 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2
224 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
225 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
226 fi
227
228 if [[ ${RELEASETYPE} == -git ]]; then
229 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2
230 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
231 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
232 fi
233
234 if [[ ${RELEASETYPE} == -rc-git ]]; then
235 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
236 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
237 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2
238 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
239 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
240 fi
241
242 debug-print-kernel2-variables
243
244 handle_genpatches
245}
246
74kernel_is() { 247kernel_is() {
75 [[ -z ${OKV} ]] && return 1 248 [[ -z ${OKV} ]] && detect_version
76 local operator test value x=0 y=0 z=0 249 local operator test value x=0 y=0 z=0
77 250
78 case ${1} in 251 case ${1} in
79 lt) operator="-lt"; shift;; 252 lt) operator="-lt"; shift;;
80 gt) operator="-gt"; shift;; 253 gt) operator="-gt"; shift;;
86 259
87 for x in ${@}; do 260 for x in ${@}; do
88 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done 261 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
89 value="${value}${x}" 262 value="${value}${x}"
90 z=$((${z} + 1)) 263 z=$((${z} + 1))
91 264
92 case ${z} in 265 case ${z} in
93 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done; 266 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
94 test="${test}${KV_MAJOR}";; 267 test="${test}${KV_MAJOR}";;
95 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done; 268 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
96 test="${test}${KV_MINOR}";; 269 test="${test}${KV_MINOR}";;
101 done 274 done
102 275
103 [ ${test} ${operator} ${value} ] && return 0 || return 1 276 [ ${test} ${operator} ${value} ] && return 0 || return 1
104} 277}
105 278
106
107kernel_is_2_4() { 279kernel_is_2_4() {
108 kernel_is 2 4 280 kernel_is 2 4
109} 281}
110 282
111kernel_is_2_6() { 283kernel_is_2_6() {
112 kernel_is 2 6 || kernel_is 2 5 284 kernel_is 2 6 || kernel_is 2 5
113}
114
115kernel_header_destdir() {
116 [[ ${CTARGET} == ${CHOST} ]] \
117 && echo /usr/include \
118 || echo /usr/${CTARGET}/include
119} 285}
120 286
121# Capture the sources type and set DEPENDs 287# Capture the sources type and set DEPENDs
122if [[ ${ETYPE} == sources ]]; then 288if [[ ${ETYPE} == sources ]]; then
123 DEPEND="!build? ( sys-apps/sed 289 DEPEND="!build? ( sys-apps/sed
124 >=sys-devel/binutils-2.11.90.0.31 ) 290 >=sys-devel/binutils-2.11.90.0.31 )"
125 doc? ( app-text/docbook-sgml-utils )"
126 RDEPEND="${DEPEND}
127 !build? ( >=sys-libs/ncurses-5.2 291 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
128 sys-devel/make )" 292 sys-devel/make )"
293 PDEPEND="virtual/dev-manager"
129 294
130 PROVIDE="virtual/linux-sources" 295 PROVIDE="virtual/linux-sources"
131 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa" 296 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
297
132 SLOT="${PVR}" 298 SLOT="${PVR}"
133 DESCRIPTION="Sources for the Linux kernel" 299 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel"
134 IUSE="${IUSE} symlink build doc" 300 IUSE="symlink build"
135elif [[ ${ETYPE} == headers ]]; then 301elif [[ ${ETYPE} == headers ]]; then
136 DESCRIPTION="Linux system headers" 302 DESCRIPTION="Linux system headers"
137 IUSE="${IUSE}" 303
138 304 # Since we should NOT honour KBUILD_OUTPUT in headers
305 # lets unset it here.
306 unset KBUILD_OUTPUT
307
139 if [[ ${CTARGET} = ${CHOST} ]]; then 308 if [[ ${CTARGET} = ${CHOST} ]]; then
140 DEPEND="!virtual/os-headers" 309 DEPEND="!virtual/os-headers"
141 PROVIDE="virtual/kernel virtual/os-headers" 310 PROVIDE="virtual/os-headers"
142 SLOT="0" 311 SLOT="0"
143 else 312 else
144 SLOT="${CTARGET}" 313 SLOT="${CTARGET}"
145 fi 314 fi
146else 315else
147 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 316 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
148 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 317 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
149fi 318fi
150 319
320# Cross-compile support functions
321#==============================================================
322kernel_header_destdir() {
323 [[ ${CTARGET} == ${CHOST} ]] \
324 && echo /usr/include \
325 || echo /usr/${CTARGET}/usr/include
326}
327
328cross_pre_c_headers() {
329 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
330}
331
332env_setup_xmakeopts() {
333 # Kernel ARCH != portage ARCH
334 export KARCH=$(tc-arch-kernel)
335
336 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
337 # variables properly or bad things happen !
338 xmakeopts="ARCH=${KARCH}"
339 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
340 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
341 elif type -p ${CHOST}-ar > /dev/null ; then
342 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
343 fi
344 export xmakeopts
345}
346
151# Unpack functions 347# Unpack functions
152#============================================================== 348#==============================================================
153unpack_2_4() { 349unpack_2_4() {
154 cd ${S}
155 # this file is required for other things to build properly, 350 # this file is required for other things to build properly,
156 # so we autogenerate it 351 # so we autogenerate it
157 make mrproper || die "make mrproper died" 352 make -s mrproper ${xmakeopts} || die "make mrproper failed"
353 make -s symlinks ${xmakeopts} || die "make symlinks failed"
158 make include/linux/version.h || die "make include/linux/version.h failed" 354 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
159 echo ">>> version.h compiled successfully." 355 echo ">>> version.h compiled successfully."
356}
357
358unpack_2_6() {
359 # this file is required for other things to build properly, so we
360 # autogenerate it ... generate a .config to keep version.h build from
361 # spitting out an annoying warning
362 make -s mrproper ${xmakeopts} 2>/dev/null \
363 || die "make mrproper failed"
364
365 # quick fix for bug #132152 which triggers when it cannot include linux
366 # headers (ie, we have not installed it yet)
367 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
368 touch .config
369 eerror "make defconfig failed."
370 eerror "assuming you dont have any headers installed yet and continuing"
371 epause 5
372 fi
373
374 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
375 || die "make include/linux/version.h failed"
376 rm -f .config >/dev/null
160} 377}
161 378
162universal_unpack() { 379universal_unpack() {
163 cd ${WORKDIR} 380 cd ${WORKDIR}
164 unpack linux-${OKV}.tar.bz2 381 unpack linux-${OKV}.tar.bz2
382 if [[ -d "linux" ]]; then
383 mv linux linux-${KV_FULL} \
384 || die "Unable to move source tree to ${KV_FULL}."
165 if [[ "${OKV}" != "${KV_FULL}" ]]; then 385 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
166 mv linux-${OKV} linux-${KV_FULL} \ 386 mv linux-${OKV} linux-${KV_FULL} \
167 || die "Unable to move source tree to ${KV_FULL}." 387 || die "Unable to move source tree to ${KV_FULL}."
168 fi 388 fi
169 cd ${S} 389 cd "${S}"
170 390
171 # remove all backup files 391 # remove all backup files
172 find . -iname "*~" -exec rm {} \; 2> /dev/null 392 find . -iname "*~" -exec rm {} \; 2> /dev/null
173 393
174 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox 394 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
175 use ppc && \ 395 # only do this for kernel < 2.6.27 since this file does not exist in later
396 # kernels
397 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
398 then
399 sed -i \
176 sed -ie 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \ 400 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
177 ${S}/arch/ppc/Makefile 401 "${S}"/arch/ppc/Makefile
402 else
403 sed -i \
404 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
405 "${S}"/arch/powerpc/Makefile
406 fi
178} 407}
179 408
180unpack_set_extraversion() { 409unpack_set_extraversion() {
181 cd ${S} 410 cd "${S}"
182 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile 411 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
183 cd ${OLDPWD} 412 cd "${OLDPWD}"
184} 413}
185 414
186# Should be done after patches have been applied 415# Should be done after patches have been applied
187# Otherwise patches that modify the same area of Makefile will fail 416# Otherwise patches that modify the same area of Makefile will fail
188unpack_fix_install_path() { 417unpack_fix_install_path() {
189 cd ${S} 418 cd "${S}"
190 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile 419 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
191}
192
193unpack_fix_docbook() {
194 if [[ -d ${S}/Documentation/DocBook ]]; then
195 cd ${S}/Documentation/DocBook
196 sed -ie "s:db2:docbook2:g" Makefile
197 cd ${OLDPWD}
198 fi
199} 420}
200 421
201# Compile Functions 422# Compile Functions
202#============================================================== 423#==============================================================
203compile_headers() { 424compile_headers() {
425 env_setup_xmakeopts
426
204 # if we couldnt obtain HOSTCFLAGS from the Makefile, 427 # if we couldnt obtain HOSTCFLAGS from the Makefile,
205 # then set it to something sane 428 # then set it to something sane
206 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS ${S}/Makefile) 429 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
207 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer} 430 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
208
209 # Kernel ARCH != portage ARCH
210 local KARCH=$(tc-arch-kernel)
211
212 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
213 # variables properly or bad things happen !
214 local xmakeopts="ARCH=${KARCH}"
215 if [[ ${CTARGET} != ${CHOST} ]]; then
216 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
217 elif type -p ${CHOST}-ar; then
218 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
219 fi
220 431
221 if kernel_is 2 4; then 432 if kernel_is 2 4; then
222 yes "" | make oldconfig ${xmakeopts} 433 yes "" | make oldconfig ${xmakeopts}
223 echo ">>> make oldconfig complete" 434 echo ">>> make oldconfig complete"
224 use sparc && make dep ${xmakeopts} 435 make dep ${xmakeopts}
225 elif kernel_is 2 6; then 436 elif kernel_is 2 6; then
437 # 2.6.18 introduces headers_install which means we dont need any
438 # of this crap anymore :D
439 kernel_is ge 2 6 18 && return 0
440
226 # autoconf.h isnt generated unless it already exists. plus, we have 441 # autoconf.h isnt generated unless it already exists. plus, we have
227 # no guarantee that any headers are installed on the system... 442 # no guarantee that any headers are installed on the system...
228 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \ 443 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
229 || touch include/linux/autoconf.h 444 || touch include/linux/autoconf.h
230 445
231 # if K_DEFCONFIG isn't set, force to "defconfig" 446 # if K_DEFCONFIG isn't set, force to "defconfig"
232 # needed by mips 447 # needed by mips
233 if [[ -z ${K_DEFCONFIG} ]]; then 448 if [[ -z ${K_DEFCONFIG} ]]; then
449 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
450 case ${CTARGET} in
451 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
452 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
453 *) K_DEFCONFIG="defconfig";;
454 esac
455 else
234 K_DEFCONFIG="defconfig" 456 K_DEFCONFIG="defconfig"
457 fi
235 fi 458 fi
236 459
237 # if there arent any installed headers, then there also isnt an asm 460 # if there arent any installed headers, then there also isnt an asm
238 # symlink in /usr/include/, and make defconfig will fail, so we have 461 # symlink in /usr/include/, and make defconfig will fail, so we have
239 # to force an include path with $S. 462 # to force an include path with $S.
240 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/" 463 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
241 ln -sf asm-${KARCH} "${S}"/include/asm 464 ln -sf asm-${KARCH} "${S}"/include/asm
465 cross_pre_c_headers && return 0
466
242 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed" 467 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
468 if compile_headers_tweak_config ; then
469 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
470 fi
243 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 471 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
244 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 472 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
245 fi 473 fi
246} 474}
247 475
248compile_manpages() { 476compile_headers_tweak_config() {
249 einfo "Making manpages ..." 477 # some targets can be very very picky, so let's finesse the
250 env -u ARCH make mandocs 478 # .config based upon any info we may have
479 case ${CTARGET} in
480 sh*)
481 sed -i '/CONFIG_CPU_SH/d' .config
482 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
483 return 0;;
484 esac
485
486 # no changes, so lets do nothing
487 return 1
251} 488}
252 489
253# install functions 490# install functions
254#============================================================== 491#==============================================================
255install_universal() { 492install_universal() {
256 #fix silly permissions in tarball 493 #fix silly permissions in tarball
257 cd ${WORKDIR} 494 cd ${WORKDIR}
258 chown -R root:root * 495 chown -R root:0 * >& /dev/null
259 chmod -R a+r-w+X,u+w * 496 chmod -R a+r-w+X,u+w *
260 cd ${OLDPWD} 497 cd ${OLDPWD}
261} 498}
262 499
263install_headers() { 500install_headers() {
264 local ddir=$(kernel_header_destdir) 501 local ddir=$(kernel_header_destdir)
265 502
503 # 2.6.18 introduces headers_install which means we dont need any
504 # of this crap anymore :D
505 if kernel_is ge 2 6 18 ; then
506 env_setup_xmakeopts
507 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
508
509 # let other packages install some of these headers
510 rm -rf "${D}"/${ddir}/sound #alsa-headers
511 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
512 return 0
513 fi
514
515 # Do not use "linux/*" as that can cause problems with very long
516 # $S values where the cmdline to cp is too long
266 cd ${S} 517 cd "${S}"
267 dodir ${ddir}/linux 518 dodir ${ddir}/linux
268 cp -ax ${S}/include/linux/* ${D}/${ddir}/linux 519 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
269 rm -rf ${D}/${ddir}/linux/modules 520 rm -rf "${D}"/${ddir}/linux/modules
270 521
271 # Handle multilib headers 522 # Handle multilib headers and crap
523 local multi_dirs="" multi_defs=""
272 case $(tc-arch-kernel) in 524 case $(tc-arch-kernel) in
273 sparc64) 525 sparc64)
274 dodir ${ddir}/asm-sparc 526 multi_dirs="sparc sparc64"
275 cp -ax ${S}/include/asm-sparc/* ${D}/${ddir}/asm-sparc 527 multi_defs="!__arch64__ __arch64__"
276
277 dodir ${ddir}/asm-sparc64
278 cp -ax ${S}/include/asm-sparc64/* ${D}/${ddir}/asm-sparc64
279
280 create_ml_includes ${ddir}/asm !__arch64__:${ddir}/asm-sparc __arch64__:${ddir}/asm-sparc64
281 ;; 528 ;;
282 x86_64) 529 x86_64)
530 multi_dirs="i386 x86_64"
531 multi_defs="__i386__ __x86_64__"
532 ;;
533 ppc64)
534 multi_dirs="ppc ppc64"
535 multi_defs="!__powerpc64__ __powerpc64__"
536 ;;
537 s390x)
538 multi_dirs="s390 s390x"
539 multi_defs="!__s390x__ __s390x__"
540 ;;
541 arm)
283 dodir ${ddir}/asm-i386 542 dodir ${ddir}/asm
284 cp -ax ${S}/include/asm-i386/* ${D}/${ddir}/asm-i386 543 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
285 544 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch
545 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc
546 ;;
547 powerpc)
286 dodir ${ddir}/asm-x86_64 548 dodir ${ddir}/asm
287 cp -ax ${S}/include/asm-x86_64/* ${D}/${ddir}/asm-x86_64 549 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
288 550 if [[ -e "${S}"/include/asm-ppc ]] ; then
289 create_ml_includes ${ddir}/asm __i386__:${ddir}/asm-i386 __x86_64__:${ddir}/asm-x86_64 551 dodir ${ddir}/asm-ppc
552 cp -pPR "${S}"/include/asm-ppc/* ${D}/${ddir}/asm-ppc
553 fi
290 ;; 554 ;;
291 *) 555 *)
292 dodir ${ddir}/asm 556 dodir ${ddir}/asm
293 cp -ax ${S}/include/asm/* ${D}/${ddir}/asm 557 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
294 ;; 558 ;;
295 esac 559 esac
560 if [[ -n ${multi_dirs} ]] ; then
561 local d ml_inc=""
562 for d in ${multi_dirs} ; do
563 dodir ${ddir}/asm-${d}
564 cp -pPR "${S}"/include/asm-${d}/* ${D}/${ddir}/asm-${d}/ || die "cp asm-${d} failed"
565
566 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}"
567 multi_defs=${multi_defs#* }
568 done
569 create_ml_includes ${ddir}/asm ${ml_inc}
570 fi
296 571
297 if kernel_is 2 6; then 572 if kernel_is 2 6; then
298 dodir ${ddir}/asm-generic 573 dodir ${ddir}/asm-generic
299 cp -ax ${S}/include/asm-generic/* ${D}/${ddir}/asm-generic 574 cp -pPR "${S}"/include/asm-generic/* ${D}/${ddir}/asm-generic
300 fi 575 fi
301 576
302 # clean up 577 # clean up
303 find "${D}" -name '*.orig' -exec rm -f {} \; 578 find "${D}" -name '*.orig' -exec rm -f {} \;
304 579
305 cd ${OLDPWD} 580 cd ${OLDPWD}
306} 581}
307 582
308install_sources() { 583install_sources() {
309 local doc docs file 584 local file
310 585
311 cd ${S} 586 cd "${S}"
312 dodir /usr/src 587 dodir /usr/src
313 echo ">>> Copying sources ..." 588 echo ">>> Copying sources ..."
314 589
315 file="$(find ${WORKDIR} -iname "docs" -type d)" 590 file="$(find ${WORKDIR} -iname "docs" -type d)"
316 if [[ -n ${file} ]]; then 591 if [[ -n ${file} ]]; then
317 for file in $(find ${file} -type f); do 592 for file in $(find ${file} -type f); do
318 echo "${file//*docs\/}" >> ${S}/patches.txt 593 echo "${file//*docs\/}" >> "${S}"/patches.txt
319 echo "===================================================" >> ${S}/patches.txt 594 echo "===================================================" >> "${S}"/patches.txt
320 cat ${file} >> ${S}/patches.txt 595 cat ${file} >> "${S}"/patches.txt
321 echo "===================================================" >> ${S}/patches.txt 596 echo "===================================================" >> "${S}"/patches.txt
322 echo "" >> ${S}/patches.txt 597 echo "" >> "${S}"/patches.txt
323 done 598 done
324 fi 599 fi
325 600
326 if [[ ! -f ${S}/patches.txt ]]; then 601 if [[ ! -f ${S}/patches.txt ]]; then
327 # patches.txt is empty so lets use our ChangeLog 602 # patches.txt is empty so lets use our ChangeLog
328 [[ -f ${FILESDIR}/../ChangeLog ]] && \ 603 [[ -f ${FILESDIR}/../ChangeLog ]] && \
329 echo "Please check the ebuild ChangeLog for more details." \ 604 echo "Please check the ebuild ChangeLog for more details." \
330 > ${S}/patches.txt 605 > "${S}"/patches.txt
331 fi 606 fi
332
333 for doc in ${UNIPATCH_DOCS}; do [[ -f ${doc} ]] && docs="${docs} ${doc}"; done
334 if [[ -f ${S}/patches.txt ]]; then docs="${docs} ${S}/patches.txt"; fi
335 use doc && ! use arm && ! use s390 && install_manpages
336 dodoc ${docs}
337 607
338 mv ${WORKDIR}/linux* ${D}/usr/src 608 mv ${WORKDIR}/linux* ${D}/usr/src
339}
340
341install_manpages() {
342 sed -ie "s#/usr/local/man#${D}/usr/man#g" scripts/makeman
343 ebegin "Installing manpages"
344 env -u ARCH make installmandocs
345 eend $?
346 sed -ie "s#${D}/usr/man#/usr/local/man#g" scripts/makeman
347} 609}
348 610
349# pkg_preinst functions 611# pkg_preinst functions
350#============================================================== 612#==============================================================
351preinst_headers() { 613preinst_headers() {
356 618
357# pkg_postinst functions 619# pkg_postinst functions
358#============================================================== 620#==============================================================
359postinst_sources() { 621postinst_sources() {
360 local MAKELINK=0 622 local MAKELINK=0
361 623
362 # if we have USE=symlink, then force K_SYMLINK=1 624 # if we have USE=symlink, then force K_SYMLINK=1
363 use symlink && K_SYMLINK=1 625 use symlink && K_SYMLINK=1
364 626
365 # if we are to forcably symlink, delete it if it already exists first. 627 # if we are to forcably symlink, delete it if it already exists first.
366 if [[ -n ${K_SYMLINK} ]]; then 628 if [[ ${K_SYMLINK} > 0 ]]; then
367 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux 629 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
368 MAKELINK=1 630 MAKELINK=1
369 fi 631 fi
370 632
371 # if the link doesnt exist, lets create it 633 # if the link doesnt exist, lets create it
372 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1 634 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
373 635
374 if [[ ${MAKELINK} == 1 ]]; then 636 if [[ ${MAKELINK} == 1 ]]; then
375 cd ${ROOT}usr/src 637 cd ${ROOT}usr/src
376 ln -sf linux-${KV_FULL} linux 638 ln -sf linux-${KV_FULL} linux
377 cd ${OLDPWD} 639 cd ${OLDPWD}
378 fi 640 fi
379 641
380 # Don't forget to make directory for sysfs 642 # Don't forget to make directory for sysfs
381 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys 643 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
382 644
383 echo 645 echo
384 einfo "After installing a new kernel of any version, it is important"
385 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y"
386 einfo "created (X.Y is the first 2 parts of your new kernel version)"
387 echo
388 einfo "For example, this kernel will require:"
389 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
390 echo
391 einfo "If you are upgrading from a previous kernel, you may be interested" 646 elog "If you are upgrading from a previous kernel, you may be interested"
392 einfo "in the following documents:" 647 elog "in the following document:"
393 einfo " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml" 648 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
394 kernel_is_2_6 && einfo " - 2.4 to 2.6 migration guide: http://www.gentoo.org/doc/en/migration-to-2.6.xml"
395 echo 649 echo
396 650
397 # if K_EXTRAEINFO is set then lets display it now 651 # if K_EXTRAEINFO is set then lets display it now
398 if [[ -n ${K_EXTRAEINFO} ]]; then 652 if [[ -n ${K_EXTRAEINFO} ]]; then
399 echo ${K_EXTRAEINFO} | fmt | 653 echo ${K_EXTRAEINFO} | fmt |
400 while read -s ELINE; do einfo "${ELINE}"; done 654 while read -s ELINE; do einfo "${ELINE}"; done
401 fi 655 fi
402 656
657 # if K_EXTRAELOG is set then lets display it now
658 if [[ -n ${K_EXTRAELOG} ]]; then
659 echo ${K_EXTRAELOG} | fmt |
660 while read -s ELINE; do elog "${ELINE}"; done
661 fi
662
403 # if K_EXTRAEWARN is set then lets display it now 663 # if K_EXTRAEWARN is set then lets display it now
404 if [[ -n ${K_EXTRAEWARN} ]]; then 664 if [[ -n ${K_EXTRAEWARN} ]]; then
405 echo ${K_EXTRAEWARN} | fmt | 665 echo ${K_EXTRAEWARN} | fmt |
406 while read -s ELINE; do ewarn "${ELINE}"; done 666 while read -s ELINE; do ewarn "${ELINE}"; done
407 fi 667 fi
668
669 # optionally display security unsupported message
670 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
671 echo
672 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
673 ewarn "This means that it is likely to be vulnerable to recent security issues."
674 ewarn "For specific information on why this kernel is unsupported, please read:"
675 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
676 fi
677
678 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
679 KV_MAJOR=$(get_version_component_range 1 ${OKV})
680 KV_MINOR=$(get_version_component_range 2 ${OKV})
681 KV_PATCH=$(get_version_component_range 3 ${OKV})
682 if [[ "$(tc-arch)" = "sparc" ]] \
683 && [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
684 then
685 echo
686 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
687 elog "you now need to do"
688 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
689 elog "instead of just"
690 elog " make"
691 elog "to compile the kernel. For more information please browse to"
692 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
693 echo
694 fi
408} 695}
409 696
410postinst_headers() { 697postinst_headers() {
411 einfo "Kernel headers are usually only used when recompiling glibc, as such, following the installation" 698 elog "Kernel headers are usually only used when recompiling your system libc, as"
412 einfo "of newer headers, it is advised that you re-merge glibc as follows:" 699 elog "such, following the installation of newer headers, it is advised that you"
413 einfo "emerge glibc" 700 elog "re-merge your system libc."
414 einfo "Failure to do so will cause glibc to not make use of newer features present in the updated kernel" 701 elog "Failure to do so will cause your system libc to not make use of newer"
415 einfo "headers." 702 elog "features present in the updated kernel headers."
416} 703}
417 704
418# pkg_setup functions 705# pkg_setup functions
419#============================================================== 706#==============================================================
420setup_headers() { 707setup_headers() {
434 721
435# unipatch 722# unipatch
436#============================================================== 723#==============================================================
437unipatch() { 724unipatch() {
438 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE 725 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
439 local STRICT_COUNT PATCH_LEVEL myLC_ALL 726 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG extglob_bak
440 727
441 # set to a standard locale to ensure sorts are ordered properly. 728 # set to a standard locale to ensure sorts are ordered properly.
442 myLC_ALL="${LC_ALL}" 729 myLC_ALL="${LC_ALL}"
730 myLANG="${LANG}"
443 LC_ALL="C" 731 LC_ALL="C"
732 LANG=""
444 733
445 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 734 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
446 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 735 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
447 736
448 # We're gonna need it when doing patches with a predefined patchlevel 737 # We're gonna need it when doing patches with a predefined patchlevel
738 extglob_bak=$(shopt -p extglob)
449 shopt -s extglob 739 shopt -s extglob
450 740
451 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 741 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
452 # usage can be either via an env var or by params 742 # usage can be either via an env var or by params
453 # although due to the nature we pass this within this eclass 743 # although due to the nature we pass this within this eclass
455 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}" 745 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
456 UNIPATCH_LIST="${@}" 746 UNIPATCH_LIST="${@}"
457 747
458 #unpack any passed tarballs 748 #unpack any passed tarballs
459 for i in ${UNIPATCH_LIST}; do 749 for i in ${UNIPATCH_LIST}; do
460 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ]; then 750 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
461 extention=${i/*./}
462 extention=${extention/:*/}
463 case ${extention} in
464 tbz2) PIPE_CMD="tar -xvjf";;
465 bz2) PIPE_CMD="tar -xvjf";;
466 tgz) PIPE_CMD="tar -xvzf";;
467 gz) PIPE_CMD="tar -xvzf";;
468 *) eerror "Unrecognized tarball compression"
469 die "Unrecognized tarball compression";;
470 esac
471
472 if [ -n "${UNIPATCH_STRICTORDER}" ]; then 751 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
473 unset z 752 unset z
474 STRICT_COUNT=$((${STRICT_COUNT} + 1)) 753 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
475 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++)); 754 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
476 do z="${z}0"; 755 do z="${z}0";
477 done 756 done
478 PATCH_ORDER="${z}${STRICT_COUNT}" 757 PATCH_ORDER="${z}${STRICT_COUNT}"
479 758
480 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/ 759 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
481 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR}/${PATCH_ORDER}/ 1>/dev/null 760 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
761 unpack ${i##*/}
762 popd >/dev/null
482 else 763 else
483 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR} 1>/dev/null 764 pushd "${KPATCH_DIR}" >/dev/null
765 unpack ${i##*/}
766 popd >/dev/null
484 fi 767 fi
485 768
486 if [ $? == 0 ]; then
487 einfo "${i/*\//} unpacked"
488 [ -n "$(echo ${i} | grep ':')" ] && echo ">>> Strict patch levels not currently supported for tarballed patchsets" 769 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
489 else
490 eerror "Failed to unpack ${i/:*/}"
491 die "unable to unpack patch tarball"
492 fi
493 else 770 else
494 extention=${i/*./} 771 extention=${i/*./}
495 extention=${extention/:*/} 772 extention=${extention/:*/}
496 PIPE_CMD="" 773 PIPE_CMD=""
497 case ${extention} in 774 case ${extention} in
518 die Unable to locate ${i} 795 die Unable to locate ${i}
519 fi 796 fi
520 797
521 if [ -n "${UNIPATCH_STRICTORDER}" ]; then 798 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
522 unset z 799 unset z
523 STRICT_COUNT=$((${STRICT_COUNT} + 1)) 800 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
524 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++)); 801 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
525 do z="${z}0"; 802 do z="${z}0";
526 done 803 done
527 PATCH_ORDER="${z}${STRICT_COUNT}" 804 PATCH_ORDER="${z}${STRICT_COUNT}"
528 805
540 KPATCH_DIR="" 817 KPATCH_DIR=""
541 for i in $(find ${x} -type d | sort -n); do 818 for i in $(find ${x} -type d | sort -n); do
542 KPATCH_DIR="${KPATCH_DIR} ${i}" 819 KPATCH_DIR="${KPATCH_DIR} ${i}"
543 done 820 done
544 821
822 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
823 # bug #272676
824 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
825 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
826 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
827 echo
828 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
829 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
830 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
831 echo
832 fi
833 fi
834
545 #so now lets get rid of the patchno's we want to exclude 835 #so now lets get rid of the patchno's we want to exclude
546 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}" 836 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
547 for i in ${UNIPATCH_DROP}; do 837 for i in ${UNIPATCH_DROP}; do
548 ebegin "Excluding Patch #${i}" 838 ebegin "Excluding Patch #${i}"
549 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done 839 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
562 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi 852 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
563 853
564 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)" 854 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
565 while [ ${PATCH_DEPTH} -lt 5 ]; do 855 while [ ${PATCH_DEPTH} -lt 5 ]; do
566 echo "Attempting Dry-run:" >> ${STDERR_T} 856 echo "Attempting Dry-run:" >> ${STDERR_T}
567 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T} 857 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
568 echo "=======================================================" >> ${STDERR_T} 858 echo "=======================================================" >> ${STDERR_T}
569 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then 859 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
570 echo "Attempting patch:" > ${STDERR_T} 860 echo "Attempting patch:" > ${STDERR_T}
571 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T} 861 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
572 echo "=======================================================" >> ${STDERR_T} 862 echo "=======================================================" >> ${STDERR_T}
573 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then 863 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
574 eend 0 864 eend 0
575 rm ${STDERR_T} 865 rm ${STDERR_T}
576 break 866 break
577 else 867 else
578 eend 1 868 eend 1
590 die "Unable to dry-run patch." 880 die "Unable to dry-run patch."
591 fi 881 fi
592 done 882 done
593 done 883 done
594 884
885 # This is a quick, and kind of nasty hack to deal with UNIPATCH_DOCS which
886 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
887 # which is why I'm not taking too much time over this.
888 local tmp
889 for i in ${UNIPATCH_DOCS}; do
890 tmp="${tmp} ${i//*\/}"
891 cp -f ${i} ${T}/
892 done
893 UNIPATCH_DOCS="${tmp}"
894
595 # clean up KPATCH_DIR's - fixes bug #53610 895 # clean up KPATCH_DIR's - fixes bug #53610
596 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done 896 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
597 897
598 LC_ALL="${myLC_ALL}" 898 LC_ALL="${myLC_ALL}"
899 LANG="${myLANG}"
900 eval ${extglob_bak}
599} 901}
600 902
601# getfilevar accepts 2 vars as follows: 903# getfilevar accepts 2 vars as follows:
602# getfilevar <VARIABLE> <CONFIGFILE> 904# getfilevar <VARIABLE> <CONFIGFILE>
603# pulled from linux-info 905# pulled from linux-info
604 906
605getfilevar() { 907getfilevar() {
606 local workingdir basefname basedname xarch=$(tc-arch-kernel) 908 local workingdir basefname basedname xarch=$(tc-arch-kernel)
607 909
608 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then 910 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
609 ebeep
610 echo -e "\n" 911 echo -e "\n"
611 eerror "getfilevar requires 2 variables, with the second a valid file." 912 eerror "getfilevar requires 2 variables, with the second a valid file."
612 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 913 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
613 else 914 else
614 workingdir=${PWD} 915 workingdir=${PWD}
615 basefname=$(basename ${2}) 916 basefname=$(basename ${2})
616 basedname=$(dirname ${2}) 917 basedname=$(dirname ${2})
617 unset ARCH 918 unset ARCH
618 919
619 cd ${basedname} 920 cd ${basedname}
620 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \ 921 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
621 make ${BUILD_FIXES} -f - e 2>/dev/null 922 make ${BUILD_FIXES} -s -f - e 2>/dev/null
622 cd ${workingdir} 923 cd ${workingdir}
623 924
624 ARCH=${xarch} 925 ARCH=${xarch}
625 fi 926 fi
626}
627
628detect_version() {
629 # this function will detect and set
630 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
631 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
632 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
633
634 if [[ -n ${KV_FULL} ]]; then
635 # we will set this for backwards compatibility.
636 KV=${KV_FULL}
637
638 # we know KV_FULL so lets stop here. but not without resetting S
639 S=${WORKDIR}/linux-${KV_FULL}
640 return
641 fi
642
643 # CKV is used as a comparison kernel version, which is used when
644 # PV doesnt reflect the genuine kernel version.
645 # this gets set to the portage style versioning. ie:
646 # CKV=2.6.11_rc4
647 CKV=${CKV:-${PV}}
648 OKV=${OKV:-${CKV}}
649 OKV=${OKV/_beta/-test}
650 OKV=${OKV/_rc/-rc}
651 OKV=${OKV/-r*}
652 OKV=${OKV/_p*}
653
654 KV_MAJOR=$(get_version_component_range 1 ${OKV})
655 KV_MINOR=$(get_version_component_range 2 ${OKV})
656 KV_PATCH=$(get_version_component_range 3- ${OKV})
657 KV_PATCH=${KV_PATCH/[-_]*}
658
659 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
660
661 RELEASE=${CKV/${OKV}}
662 RELEASE=${RELEASE/_beta}
663 RELEASE=${RELEASE/_rc/-rc}
664 RELEASE=${RELEASE/_pre/-pre}
665 kernel_is_2_6 && RELEASE=${RELEASE/-pre/-bk}
666 RELEASETYPE=${RELEASE//[0-9]}
667
668 # Now we know that RELEASE is the -rc/-bk
669 # and RELEASETYPE is the same but with its numerics stripped
670 # we can work on better sorting EXTRAVERSION.
671 # first of all, we add the release
672 EXTRAVERSION="${RELEASE}"
673
674 if [[ -n ${K_PREPATCHED} ]]; then
675 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
676 elif [[ "${ETYPE}" = "sources" ]]; then
677 # For some sources we want to use the PV in the extra version
678 # This is because upstream releases with a completely different
679 # versioning scheme.
680 case ${PN/-*} in
681 wolk) K_USEPV=1;;
682 vserver) K_USEPV=1;;
683 esac
684
685 [[ -z ${K_NOUSENAME} ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
686 [[ -n ${K_USEPV} ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
687 [[ -n ${PR//r0} ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
688 fi
689
690 KV_FULL=${OKV}${EXTRAVERSION}
691
692 # -rc-bk pulls can be achieved by specifying CKV
693 # for example:
694 # CKV="2.6.11_rc3_pre2"
695 # will pull:
696 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-bk2.bz2
697
698 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
699 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
700 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2
701 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
702 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
703 fi
704
705 if [[ ${RELEASETYPE} == -bk ]]; then
706 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2
707 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
708 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
709 fi
710
711 if [[ ${RELEASETYPE} == -rc-bk ]]; then
712 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
713 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
714 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-bk*}.bz2
715 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
716 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-bk*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
717 fi
718
719 # we will set this for backwards compatibility.
720 S=${WORKDIR}/linux-${KV_FULL}
721 KV=${KV_FULL}
722} 927}
723 928
724detect_arch() { 929detect_arch() {
725 # This function sets ARCH_URI and ARCH_PATCH 930 # This function sets ARCH_URI and ARCH_PATCH
726 # with the neccessary info for the arch sepecific compatibility 931 # with the neccessary info for the arch sepecific compatibility
732 # ARCH_URI is the URI for all the ${ARCH}_URI patches 937 # ARCH_URI is the URI for all the ${ARCH}_URI patches
733 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH 938 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
734 939
735 ARCH_URI="" 940 ARCH_URI=""
736 ARCH_PATCH="" 941 ARCH_PATCH=""
737 ALL_ARCH="X86 PPC PPC64 SPARC MIPS ALPHA ARM HPPA AMD64 IA64 X86OBSD S390 SH" 942 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
738 943
739 for LOOP_ARCH in ${ALL_ARCH}; do 944 for LOOP_ARCH in ${ALL_ARCH}; do
740 COMPAT_URI="${LOOP_ARCH}_URI" 945 COMPAT_URI="${LOOP_ARCH}_URI"
741 COMPAT_URI="${!COMPAT_URI}" 946 COMPAT_URI="${!COMPAT_URI}"
742 947
812 return 0 1017 return 0
813} 1018}
814 1019
815headers___fix() { 1020headers___fix() {
816 # Voodoo to partially fix broken upstream headers. 1021 # Voodoo to partially fix broken upstream headers.
817 # Issues with this function should go to plasmaroo. 1022 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
818 sed -i \ 1023 sed -i \
819 -e "s/\([ "$'\t'"]\)u8\([ "$'\t'"]\)/\1__u8\2/g;" \ 1024 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
820 -e "s/\([ "$'\t'"]\)u16\([ "$'\t'"]\)/\1__u16\2/g;" \
821 -e "s/\([ "$'\t'"]\)u32\([ "$'\t'"]\)/\1__u32\2/g;" \
822 -e "s/\([ "$'\t'"]\)u64\([ "$'\t'"]\)/\1__u64\2/g;" \
823 -e "s/\([ "$'\t'"]\)s64\([ "$'\t'"]\)/\1__s64\2/g;" \
824 -e 's/ \(u\|s\)\(8\|16\|32\|64\)$/ __\1\2/g' \ 1025 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
825 -e 's/\([(, ]\)\(u\|s\)64\([, )]\)/\1__\264\3/g' \ 1026 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
1027 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1028 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
826 "$@" 1029 "$@"
827} 1030}
828 1031
829# common functions 1032# common functions
830#============================================================== 1033#==============================================================
831kernel-2_src_unpack() { 1034kernel-2_src_unpack() {
832 universal_unpack 1035 universal_unpack
1036 debug-print "Doing unipatch"
833 1037
834 [[ -n ${UNIPATCH_LIST} ]] || [[ -n ${UNIPATCH_LIST_DEFAULT} ]] && \ 1038 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
835 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST}" 1039 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1040
1041 debug-print "Doing premake"
1042
1043 # allow ebuilds to massage the source tree after patching but before
1044 # we run misc `make` functions below
1045 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1046
1047 debug-print "Doing unpack_set_extraversion"
836 1048
837 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion 1049 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
838 unpack_fix_docbook
839 unpack_fix_install_path 1050 unpack_fix_install_path
840 1051
1052 # Setup xmakeopts and cd into sourcetree.
1053 env_setup_xmakeopts
1054 cd "${S}"
1055
1056 # We dont need a version.h for anything other than headers
1057 # at least, I should hope we dont. If this causes problems
1058 # take out the if/fi block and inform me please.
1059 # unpack_2_6 should now be 2.6.17 safe anyways
1060 if [[ ${ETYPE} == headers ]]; then
841 kernel_is 2 4 && unpack_2_4 1061 kernel_is 2 4 && unpack_2_4
1062 kernel_is 2 6 && unpack_2_6
1063 fi
842} 1064}
843 1065
844kernel-2_src_compile() { 1066kernel-2_src_compile() {
845 cd ${S} 1067 cd "${S}"
846 [[ ${ETYPE} == headers ]] && compile_headers 1068 [[ ${ETYPE} == headers ]] && compile_headers
847 [[ ${ETYPE} == sources ]] && \
848 use doc && ! use arm && ! use s390 && compile_manpages
849} 1069}
850 1070
851kernel-2_pkg_preinst() { 1071kernel-2_pkg_preinst() {
852 [[ ${ETYPE} == headers ]] && preinst_headers 1072 [[ ${ETYPE} == headers ]] && preinst_headers
853} 1073}
862 [[ ${ETYPE} == headers ]] && postinst_headers 1082 [[ ${ETYPE} == headers ]] && postinst_headers
863 [[ ${ETYPE} == sources ]] && postinst_sources 1083 [[ ${ETYPE} == sources ]] && postinst_sources
864} 1084}
865 1085
866kernel-2_pkg_setup() { 1086kernel-2_pkg_setup() {
1087 if kernel_is 2 4; then
1088 if [ "$( gcc-major-version )" -eq "4" ] ; then
1089 echo
1090 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1091 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1092 ewarn "newer kernel that supports gcc-4."
1093 echo
1094 ewarn "Also be aware that bugreports about gcc-4 not working"
1095 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1096 echo
1097 epause 10
1098 fi
1099 fi
1100
1101 ABI="${KERNEL_ABI}"
867 [[ ${ETYPE} == headers ]] && setup_headers 1102 [[ ${ETYPE} == headers ]] && setup_headers
868 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..." 1103 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
869} 1104}

Legend:
Removed from v.1.113  
changed lines
  Added in v.1.221

  ViewVC Help
Powered by ViewVC 1.1.20